package io.gmss.fiscad.implementations.rfu.parametre;

import io.gmss.fiscad.entities.rfu.parametre.Exercice;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.rfu.parametre.ExerciceService;
import io.gmss.fiscad.repositories.rfu.parametre.ExerciceRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class ExerciceServiceImpl implements ExerciceService {
    private final ExerciceRepository exerciceRepository;

    public ExerciceServiceImpl(ExerciceRepository exerciceRepository) {
        this.exerciceRepository = exerciceRepository;
    }

    @Override
    public Exercice createExercice(Exercice exercice) throws BadRequestException {
        if (exercice.getId() != null) {
            throw new BadRequestException("Impossible de créer une nouvelle campgne ayant un id non null.");
        }
        return exerciceRepository.save(exercice);
    }
    @Override
    public Exercice updateExercice(Long id, Exercice exercice) throws NotFoundException {
        if (exercice.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour une nouvelle exercice ayant un id null.");
        }
        if (!exerciceRepository.existsById(exercice.getId())) {
            throw new NotFoundException("Impossible de trouver la exercice spécifiée dans notre base de données.");
        }
        return exerciceRepository.save(exercice);
    }

    @Override
    public void deleteExercice(Long id) throws NotFoundException {
        Optional<Exercice> exerciceOptional = exerciceRepository.findById(id);
        if (exerciceOptional.isPresent()) {
            exerciceRepository.deleteById(exerciceOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver la exercice spécifiée dans notre base de données.");
        }
    }
    @Override
    public Page<Exercice> getExerciceList(Pageable pageable) {
        return exerciceRepository.findAll(pageable);
    }

    @Override
    public List<Exercice> getExerciceList() {
        return exerciceRepository.findAll();
    }



    @Override
    public Optional<Exercice> getExerciceById(Long id) {
        return exerciceRepository.findById(id);
    }
}

